//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.command;


/**
 * This type was created in VisualAge
 * @author Marcel Baumann
 * @invariant
 */

import java.util.Enumeration;
import java.util.Vector;

public class CommandMode {



    // A list of the commands in the mode
    private Vector commandList;


    /**
     * CommandMode constructor comment.
     */
    public CommandMode() {
        super();
        this.commandList = new Vector(1);
    }

    /**
     * This method was created in VisualAge
     *
     * @param commandName java.lang.String
     * @author Marcel Baumann
     * @pre
     * @post
     */
    public void addCommandName(String commandName) {
        if (commandName == null) {
            throw new IllegalArgumentException("Parameter commandName cannot be null");
        }
        commandList.addElement(commandName);
    }

    /**
     * This method was created in VisualAge
     *
     * @param commandName java.lang.String
     * @return boolean
     * @author Marcel Baumann
     * @pre commandName != null
     * @post result == commandList.contains(commandName)
     */
    public boolean inMode(String commandName) {
        if (commandName == null) {
            throw new IllegalArgumentException("Parameter commandName cannot be null");
        }
        return commandList.contains(commandName);
    }

    /**
     * This method was created in VisualAge
     *
     * @param commandMode com.nexirius.framework.command.CommandMode
     * @author Marcel Baumann
     * @pre commandMore != null
     * @post all commandnames in command mode are in commandlist
     */
    public void merge(CommandMode commandMode) {
        if (commandMode == null) {
            throw new IllegalArgumentException("Parameter commandMode cannot be null");
        }
        final Enumeration moreCommandNames = commandMode.commandList.elements();
        while (moreCommandNames.hasMoreElements()) {
            String newCommand = (String) moreCommandNames.nextElement();
            commandList.addElement(newCommand);
        }

    }
}
