//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.dataeditor;

import com.nexirius.framework.datamodel.StructModel;
import com.nexirius.framework.datamodel.Viewable;
import com.nexirius.framework.dataviewer.DataViewer;
import com.nexirius.framework.dataviewer.ViewerCreator;

/**
 * This class is used by the factory to create new instances of type StructEditor
 *
 * @author Marcel Baumann
 * @see StructEditor
 */
public class StructEditorCreator implements ViewerCreator {



    public StructEditorCreator() {
    }

    public boolean isEditor() {
        return true;
    }

    public DataViewer createViewer(Viewable model) {
        if (model == null) {
            throw new IllegalArgumentException("model may not be null");
        }

        if (!(model instanceof StructModel)) {
            throw new IllegalArgumentException("model must be of type StructModel but have: " + model.getClass().getName());
        }

        return new StructEditor((StructModel) model);
    }
}
