package com.nexirius.framework.datamodel;

public interface DataModelWorker {
    public static WorkResult CONTINUE = new WorkResult("CONTINUE", 0); // continue loop
    public static WorkResult BREAK = new WorkResult("BREAK", 1); // break loop
    public static WorkResult REMOVE_ENTRY_AND_CONTINUE = new WorkResult("REMOVE_ENTRY_AND_CONTINUE", 2); // delete actual entry and continue loop
    public static WorkResult REMOVE_ENTRY_AND_BREAK = new WorkResult("REMOVE_ENTRY_AND_BREAK", 3); // delete actual entry and break loop

    /**
     * used to traverse a list of data models
     * @param model
     * @return result that indicates next loop action
     */
    public WorkResult work(DataModel model);

    public static class WorkResult {
        private int code;
        private String name;

        private WorkResult(String name, int code) {
            this.name = name;
            this.code = code;
        }

        public int getCode() {
            return code;
        }

        public String toString() {
            return name;
        }
    }
}
