package com.nexirius.framework.datamodel;

import com.nexirius.framework.application.ProgressAdaptor;

public class ProgressAdaptorModel extends StructModel implements ProgressAdaptor {
    public static final String FIELD_progressBars = "progressBars";
    private StructModel progressBars;

    public ProgressAdaptorModel() {
        super("ProgressAdaptor");
        init();
    }

    private DoubleModel getProgressModel(String name) throws Exception {
        return (DoubleModel) progressBars.getChild(name);
    }

    private void init() {
        progressBars = new StructModel(FIELD_progressBars);
        append(progressBars);
    }

    public void setProgress(String progressName, double progress) {
        DoubleModel progressModel = getOrCreateProgressModel(progressName, progress);

        progressModel.setDouble(progress);
    }

    private DoubleModel getOrCreateProgressModel(String progressName, double progress) {
        DoubleModel progressModel;
        try {
            progressModel = getProgressModel(progressName);
        } catch (Exception e) {
            progressModel = new DoubleModel(progress, progressName);
            progressBars.append(progressModel);
        }
        return progressModel;
    }

    public void setProgressText(String progressName, String text) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setConsoleText(String progressName, String text, boolean append) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setShowProgress(String progressName, boolean on) {
        try {
            DoubleModel progressModel = getProgressModel(progressName);

            progressModel.setInvisible(!on);
        } catch (Exception e) {
            if (on) {
                getOrCreateProgressModel(progressName, 0.0);
            }
        }
    }

    public void setShowProgressText(String progressName, boolean on) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void setShowConsole(String progressName, boolean on) {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
