package com.nexirius.framework.datamodel.json;

import com.nexirius.framework.datamodel.DataModel;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PushbackInputStream;

public interface IJsonFormat {
    /**
     * parse the input stream and translate the next json object into the target datamodel
     * @param in the input stream
     * @param target The data model to which the parsed content will be assigned
     */
    public void parseJson(PushbackInputStream in, DataModel target) throws Exception, JsonParseException;
    public void writeJson(DataModel source, OutputStream out) throws Exception;
}
