//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.gadgets;

import com.nexirius.util.resource.ClientResource;

import javax.swing.*;
import java.awt.*;
import java.awt.image.ImageObserver;

public class JPanelWithBackgroundImage extends JPanel {
    ImageIcon icon;

    public JPanelWithBackgroundImage(ClientResource clientResource, String imageName) {
        icon = (ImageIcon)clientResource.getIcon(imageName);
    }

    protected void paintChildren(Graphics g) {
        if (icon == null || !isOpaque()) {
            super.paintChildren(g);
            return ;
        }

        try {
            Graphics2D g2d = (Graphics2D) g;

            g2d.drawImage(icon.getImage(), 0, 0, getWidth(), getHeight(), Color.black, new ImageObserver() {
                public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height) {
                    return false;
                }
            });
        } catch (Throwable th) {
            th.printStackTrace();
        }

        super.paintChildren(g);
    }
}
