package com.nexirius.framework.htmlview.function;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.htmlview.HTMLParser;
import com.nexirius.framework.htmlview.HTMLResolver;
import com.nexirius.framework.htmlview.HTMLSessionVariable;

/**
 * This class handles the $!getChildText("childname") function
 */
public class GetChildTextHTMLFunction extends DefaultHTMLFunction {
    public String getFunctionName() {
        return "getChildText";
    }

    /**
     * access the first parameter
     *
     */
    public String getChildName() {
        return getArgument(0);
    }

    public void translate(HTMLSessionVariable sessionVariable, HTMLParser parser) throws Exception {
        DataModel model = parser.getModel();

        if (model != null) {
            String childName = getChildName();
            String childText = model.getChildText(childName);

            if (childText != null) {
                parser.getOut().write(childText.getBytes(HTMLResolver.CHARSET));
            } else {
                throw new Exception("No such SimpleModel child " + childName + " in model " + model.getClass() + " " + model.getFieldName());
            }
        }
    }
}
