package com.nexirius.framework.htmlview.function;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.json.DefaultJsonFormatMap;
import com.nexirius.framework.htmlview.HTMLParser;
import com.nexirius.framework.htmlview.HTMLResolver;
import com.nexirius.framework.htmlview.HTMLSessionVariable;

/**
 * This class handles the $!json("childName") function
 */
public class JsonHTMLFunction extends DefaultHTMLFunction {
    public String getFunctionName() {
        return "json";
    }

    /**
     * access the first parameter
     */
    public String getChildName() {
        return getArgument(0);
    }

    public void translate(HTMLSessionVariable sessionVariable, HTMLParser parser) throws Exception {
        DataModel model = parser.getModel();

        if (model != null) {
            String childName = getChildName();

            DataModel child = model.getChild(childName);

            String json = DefaultJsonFormatMap.createJson(child);

            parser.getOut().write(json.getBytes(HTMLResolver.CHARSET));
        }
    }
}
