package com.nexirius.framework.htmlview.function;

import com.nexirius.framework.htmlview.HTMLParser;
import com.nexirius.framework.htmlview.HTMLSessionVariable;


/**
 * this class handles $!switch("value", "defaulttemplate", "value1:template1", "value2:template2") functions
 * when value == value1 render template1 ....
 * else render defaulttemplate
 */
public class SwitchHTMLFunction extends DefaultHTMLFunction {

    public String getFunctionName() {
        return "switch";
    }

    public String getValue() {
        return getArgument(0);
    }
    
    public String getDefaultTemplate() {
        return getArgument(1);
    }

    public void translate(HTMLSessionVariable sessionVariable, HTMLParser parser)
            throws Exception {
        String value = getValue();
        String defaultTemplate = getDefaultTemplate();
        if(value == null || defaultTemplate == null) {
            return;
        }
        String actTemplate = defaultTemplate;
        for(int i = 2; getArgument(i) != null; i++) {
            String arg = getArgument(i);
            int index = arg.indexOf(':');
            if(index < 0) {
                continue;
            }
            String theCase = arg.substring(0, index);
            String template = arg.substring(index + 1);
            if(value.equals(theCase)) {
                actTemplate = template;
                break;
            }
        }
        
        byte result[] = parser.getResolver().resolve(sessionVariable, parser.getModel(), actTemplate, parser.isEditor());

        parser.getOut().write(result);
    }
}
