//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.layout;

import com.nexirius.framework.dataviewer.ViewerFactory;
import com.nexirius.util.SortedVector;

import javax.swing.*;
import java.util.Enumeration;

/**
 * A container for property entries.
 *
 * @author Marcel Baumann
 */
public class MultiplePropertyEntry extends SortedVector implements PropertyEntry {



    public MultiplePropertyEntry() {
    }

    public void append(PropertyEntry entry) {
        addElement(entry);
    }

    /**
     * Calls change for all the registered property entries.
     *
     * @param comp    The component which gets changed by the properties
     * @param factory The ViewerFactory which created the component
     */
    public void change(JComponent comp, ViewerFactory factory)
            throws Exception {
        Enumeration e = elements();

        while (e.hasMoreElements()) {
            PropertyEntry child = (PropertyEntry) e.nextElement();

            try {
                child.change(comp, factory);
            } catch (Exception ex) {
                //FIX
                throw new RuntimeException("Could not change component property", ex);
            }
        }
    }
}
