//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.layout;

import com.nexirius.framework.dataviewer.DataViewer;
import com.nexirius.framework.dataviewer.LayoutItem;

public class TabbedLayoutItem extends DefaultLayoutItem {



    TabbedLayoutArray layoutArray;

    public TabbedLayoutItem() {
        super();
        layoutArray = new TabbedLayoutArray();
    }

    public void doLayout(DataViewer parent_viewer) {
        // go thru all layout items and call doLayout on them

        LayoutEnumeration e = layoutArray.getEnumeration();

        while (e.hasMore()) {
            LayoutItem l = (LayoutItem) e.next();

            l.doLayout(parent_viewer);
        }

        // move and resize the JComponent
        defaultLayout(parent_viewer.getJComponent(), parent_viewer.getFactory());
    }

    public void append(TabLayoutItem layout) {
        layoutArray.append(layout);
    }
}
