//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 *
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 *
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 *
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 *
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.layout;

import com.nexirius.framework.dataviewer.DataViewer;
import com.nexirius.framework.dataviewer.TableLayoutInfo;

public class TableLayoutItem extends DefaultLayoutItem implements TableLayoutInfo
{
    protected TableColumnLayoutArray layoutArray;

    public TableLayoutItem() {
        super();
        layoutArray = new TableColumnLayoutArray();
    }

    @Override
    public void doLayout(DataViewer parent_viewer) {
        try {
            layoutArray.doLayout(parent_viewer);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
            // ignore
        }
    }

    public void clear() {
        layoutArray.clear();
    }

    public void append(TableColumnLayoutItem layout) {
        layoutArray.append(layout);
    }

    @Override
    public String getColumnLabel(int x) {
        return layoutArray.getColumnLabel(x);
    }

    @Override
    public Class<?> getColumnClass(int colindex)
    {
        return layoutArray.getColumnClass(colindex);
    }

    @Override
    public int getColumnNumber() {
        return layoutArray.getColumnNumber();
    }

    @Override
    public String getModelFieldName(int x) {
        return layoutArray.getModelFieldName(x);
    }

    public TableColumnLayoutItem getLayoutItem(int x)
    {
        return(layoutArray.getLayoutItem(x));
    }

    public TableColumnLayoutItem getLayoutItem(String fieldName)
    {
        return(layoutArray.getLayoutItem(fieldName));
    }

    public int getLayoutItemIndex(String fieldName)
    {
        return(layoutArray.getLayoutItemIndex(fieldName));
    }
}
