//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.remote;

import com.nexirius.tcp.Client;
import com.nexirius.tcp.ClientFactory;
import com.nexirius.tcp.Server;

import java.net.Socket;

/**
 * @author Marcel Baumann
 */
public class DataModelServerImpl extends DataModelServer {



    public static TestModel model = new TestModel("server side", true);

    public DataModelServerImpl(Socket socket) {
        super(socket);
    }

    public RemoteDataModel getModel(int id) {
        return model;
    }

    public static void main(String argv[]) {
        try {
            javax.swing.JFrame frame = new javax.swing.JFrame("SERVER");

            frame.addWindowListener(new MyWindowListener());

            com.nexirius.util.resource.ClientResource res = new com.nexirius.util.resource.ClientResourceImpl("TestClient");
            com.nexirius.framework.dataviewer.ViewerFactory factory = new com.nexirius.framework.dataviewer.ViewerFactory(res);

            com.nexirius.framework.dataviewer.DataViewer v = factory.createDefaultEditor(model);

            factory.setCommandProcessor(new com.nexirius.framework.command.DefaultProcessor());

            frame.getContentPane().add(v.getJComponent());

            frame.pack();
            frame.setVisible(true);

            int port = 4000;

            if (argv.length == 1) {
                port = Integer.parseInt(argv[0]);
            }

            new Server(port, new DataModelClientFactory()).start();
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}

class DataModelClientFactory implements ClientFactory {
    public Client createClient(Socket socket) {
        return new DataModelServerImpl(socket);
    }
}

class MyWindowListener extends java.awt.event.WindowAdapter {
    public void windowClosing(java.awt.event.WindowEvent e) {
        System.exit(0);
    }
}

