//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.remote;

import com.nexirius.framework.dataviewer.DataViewer;
import com.nexirius.framework.dataviewer.ViewerFactory;
import com.nexirius.tcp.ClientImpl;
import com.nexirius.util.resource.ClientResource;
import com.nexirius.util.resource.ClientResourceImpl;

import javax.swing.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.Socket;

/**
 * @author Marcel Baumann
 */
public class TestClient {



    TestModel model = new TestModel("test", false);
    Socket socket;

    TestClient()
            throws Exception {
        socket = new Socket("jungfrau", 4000);

        init();

        model.addDataModelListener(new RemoteDataModelListener(socket.getOutputStream(), socket.getInputStream()));

        JFrame frame = new JFrame();

        frame.addWindowListener(new MyWindowListener());
        ClientResource res = new ClientResourceImpl("TestClient");
        ViewerFactory factory = new ViewerFactory(res);

        factory.setCommandProcessor(new com.nexirius.framework.command.DefaultProcessor());
        DataViewer v = factory.createDefaultEditor(model);

        frame.getContentPane().add(v.getJComponent());

        frame.pack();
        frame.setVisible(true);
    }

    public void init() {
        try {
            DataModelGetEvent e = new DataModelGetEvent(1);

            socket.getOutputStream().write(DataModelRemoteEvent.COMMAND_GET.getBytes());
            e.writeDataTo(socket.getOutputStream());
            socket.getOutputStream().write('\r');

            String data = ClientImpl.readMessageFromStream(socket.getInputStream());

            model.dropData(data);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    class MyWindowListener extends WindowAdapter {
        public void windowClosing(WindowEvent e) {
            try {
                socket.close();
                System.exit(0);
            } catch (Exception ex) {
                throw new RuntimeException(ex);
            }
        }
    }

    public static void main(String argv[]) {
        try {
            new TestClient();
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}

