package com.nexirius.framework.rest.interfaces;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.json.IJsonFormatMap;
import com.nexirius.framework.datamodel.xml.DataModelXmlGenerator;

import java.io.IOException;
import java.io.OutputStream;

public interface IJnexRestRequest {
    public static final String MIME_JSON = "application/json";
    public static final String MIME_XML = "application/xml";

    public IJnexRestParameters getParameters(IJnexRestParameterExtractor parameterExtractor);
    public boolean isPost();
    public boolean isGet();
    public OutputStream getOutputStream(String mimeType) throws IOException;
    public void reply(String mimeType, Object data) throws IOException;
    public void replyJson(DataModel model, IJsonFormatMap formatMap) throws Exception;
    public void replyXml(DataModel model, DataModelXmlGenerator xmlGenerator) throws IOException;

//    public HttpServletRequest getHttpServletRequest();
//    public HttpServletResponse getHttpServletResponse();
}
