//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.swing;

import com.nexirius.framework.dataviewer.DataViewer;

/**
 * this class takes a SwingViewer and translates it into a DataViewer instance
 */
public class SwingDataViewer extends DataViewer {



    SwingViewer swingViewer;

    public SwingDataViewer(SwingViewer swingViewer) {
        super(swingViewer.getDataModel());

        this.swingViewer = swingViewer;
    }

    /**
     * Creates the actual JComponent (Actually this method is normally called the first time the getJComponent
     * method is called. The create function calls setJComponent to introduce the newly created component.
     */
    public void create() {
        setJComponent(swingViewer.createJComponent(getFactory()));
        handleInvisibleFlag(null);
    }

    /**
     * empty implementation
     */
    public void update() {
        // empty
    }

    /**
     * Returns the name of the viewer class (for debugging)
     */
    public String getViewerName() {
        return swingViewer.getClass().getName();
    }

    public SwingViewer getSwingViewer() {
        return swingViewer;
    }
}
