//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.swing.paintbutton;

import com.nexirius.framework.command.Command;
import com.nexirius.framework.command.Processor;
import com.nexirius.framework.swing.CommandJButton;
import com.nexirius.util.resource.ClientResource;

import java.awt.*;

public class PaintButton extends CommandJButton {



    static Color shadowColor = Color.gray;
    static Color foregroundColor = Color.blue;//new Color(0, 100, 0);
    Polygon polygon[];
    Color color[];

    public PaintButton(ClientResource resource, Command command, Processor processor, Point offset[], Polygon polygon[], Color color[]) {
        super(resource, command, processor);
        this.polygon = new Polygon[polygon.length];
        this.color = color;

        if (offset != null) {
            for (int i = 0; i < offset.length; ++i) {
                int x[] = new int[polygon[i].npoints];
                int y[] = new int[polygon[i].npoints];

                for (int j = 0; j < polygon[i].npoints; ++j) {
                    x[j] = polygon[i].xpoints[j] + offset[i].x;
                    y[j] = polygon[i].ypoints[j] + offset[i].y;
                }

                this.polygon[i] = new Polygon(x, y, x.length);
            }
        }
    }

    public void paint(Graphics g) {
        super.paint(g);
        g.setColor(SystemColor.control);
        g.fillRect(2, 2, 11, 11);

        if (this.hasFocus()) {
            g.setColor(new Color(150, 150, 250));
            g.fillRect(2, 2, 11, 11);
        }

        for (int i = 0; polygon != null && i < polygon.length; ++i) {
            Color col = shadowColor;

            if (this.isEnabled()) {
                if (color != null && i < color.length && color[i] != null) {
                    col = color[i];
                }
            }

            g.setColor(col);

            if (polygon[i] != null) {
                g.fillPolygon(polygon[i]);
            }
        }
    }

    public Dimension getPreferredSize() {
        return new Dimension(16, 16);
    }
}
