//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.trend;

import java.awt.*;
import java.util.Enumeration;
import java.util.Vector;

public class BasicSampleArrayModel implements SampleArrayModel {



    Vector samples = new Vector();
    Enumeration iterator = null;
    DoubleRange range = null;
    Color color = Color.red;

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public void append(SampleModel s) {
        samples.addElement(s);

        if (range == null) {
            range = new DoubleRange(s.getValue(), 0.0);
        } else {
            range.extend(s.getValue());
        }
    }

    public SampleModel getFirstSample(long begin) {
        iterator = samples.elements();

        return getNextSample(0);
    }

    public SampleModel getNextSample(long end) {
        if (iterator != null && iterator.hasMoreElements()) {
            return (SampleModel) iterator.nextElement();
        }

        return null;
    }

    public SampleModel[] getSamples(DateRange range) {
        SampleModel lastSample = getFirstSample(0);
        SampleModel actSample = getNextSample(0);

        if (actSample == null && lastSample != null && lastSample.inRange(range)) {
            SampleModel ret[] = new SampleModel[1];
            ret[0] = lastSample;

            return ret;
        }

        while (actSample != null && actSample.getTime() < range.min()) {
            actSample = getNextSample(0);
        }

        if (actSample == null) {
            return null;
        }

        Vector result = new Vector();

        result.addElement(lastSample);

        while (actSample != null && actSample.getTime() <= range.max()) {
            result.addElement(actSample);
            actSample = getNextSample(0);
        }

        actSample = getNextSample(0);

        if (actSample != null) {
            result.addElement(actSample);
        }

        return (SampleModel[]) result.toArray();
    }

    public DoubleRange getYRange(DateRange r) {
        return range;
    }
}
