//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.print;

import java.awt.*;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

public class FixPrintableTable extends PrintTable implements FixPrintable {



    public FixPrintableTable(Rectangle bounds, PageFormat pageFormat, PrintTableTemplate template, PrintTableDataAccessor data) {
        super(new Point(recalc(bounds.x, (int) pageFormat.getImageableX(), (int) pageFormat.getImageableWidth())
                , recalc(bounds.y, (int) pageFormat.getImageableY(), (int) pageFormat.getImageableHeight()))
                , template
                , data
                , recalc(bounds.width, 0, (int) pageFormat.getImageableWidth()));
    }

    public int print(Graphics gc, PageFormat pageFormat, int pageIndex) {
        Printable[] pages = preparePages(location.y, location.y + 10000, pageIndex);

        if (pages != null && pages.length > 0) {
            try {
                return pages[0].print(gc, pageFormat, pageIndex);
            } catch (PrinterException e) {
                throw new RuntimeException(e);  //TODO
            }
        }

        return PAGE_EXISTS;
    }

    public static int recalc(int v, int offset, int width) {
        return (v * width) / 100 + offset;
    }
}

