//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.tools;

import com.nexirius.util.StringVector;
import com.nexirius.util.XFile;
import com.nexirius.util.XString;

import java.io.FileOutputStream;
import java.io.PrintStream;

public class Find {



    XFile m_root;
    StringVector m_files;

    public void go(String dirname, String pat, String filePat, String fileName)
            throws Exception {
        XFile outFile = new XFile(fileName);
        FileOutputStream out = new FileOutputStream(outFile);
        PrintStream pout = new PrintStream(out);
        m_root = new XFile(dirname);
        m_files = m_root.getFiles(true, filePat);
        int n = 0;

        for (String fname = m_files.firstItem(); fname != null; fname = m_files.nextItem()) {

            if (XString.match(pat, fname)) {
                pout.println(fname);
                ++n;
            }
        }

        pout.close();
        out.close();

        System.out.println("dirname = " + dirname);
        System.out.println("pattern = " + pat);
        System.out.println("number of files = " + n);
    }

    public static void main(String argv[]) {
        Find r = new Find();

        if (argv.length < 4) {
            System.err.println("USAGE: java Find Directory DirPattern FilePattern OutFileName");
            return;
        }

        try {
            r.go(argv[0], argv[1], argv[2], argv[3]);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}

