//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.tools.properties.dataviewer;

import com.nexirius.framework.dataeditor.StructEditor;
import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.DataModelCommandVector;
import com.nexirius.framework.dataviewer.ViewerFactory;
import com.nexirius.framework.swing.SwingViewer;
import com.nexirius.tools.properties.model.EntryArrayModel;
import com.nexirius.tools.properties.model.MainModel;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;

public class MainViewer implements SwingViewer {

    protected MainModel mainModel;

    public JComponent createJComponent(ViewerFactory factory) {
        JPanel panel = new JPanel(new BorderLayout(20, 20));

        panel.setBorder(new EmptyBorder(10, 10, 10, 10)); 

        JComponent table = null;
        try {
            table = factory.createDefaultViewer(mainModel.getChild(EntryArrayModel.FIELD_NAME)).getJComponent();
            panel.add(table, BorderLayout.CENTER);

            DataModelCommandVector v = new DataModelCommandVector();

            v.add(mainModel.getMethod(MainModel.COMMAND_ADD));
            v.add(mainModel.getMethod(MainModel.COMMAND_EDIT));
            v.add(mainModel.getMethod(MainModel.COMMAND_DELETE));
            v.add(mainModel.getMethod(MainModel.COMMAND_DUPLICATE));

            panel.add(StructEditor.createButtonPanel(factory, v, true), BorderLayout.SOUTH);

        } catch (Exception e) {
            throw new RuntimeException(e);  //TODO
        }

        return panel;
    }

    public boolean isEditor() {
        return true;
    }

    public void setDataModel(DataModel model) {
        mainModel = (MainModel) model;
    }

    public DataModel getDataModel() {
        return mainModel;
    }
}
