//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.tools.properties.layout;

import com.nexirius.framework.layout.*;

import java.awt.*;

public class EntryLayout extends StructureLayoutItem {



    public EntryLayout(String locale[]) {
        GridBagConstraints fconstr = new GridBagConstraints(0, 0, 0, 0, 1.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(10, 10, 10, 10), 0, 0);
        GridBagConstraints lconstr = new GridBagConstraints(0, 0, 0, 0, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0);
        MultiplePropertyEntry fieldProps = new MultiplePropertyEntry();

        fieldProps.append(new SinglePropertyEntry("setPreferredSize", new Dimension(200, 20)));

        int y = 0;
        append(new GridBagLabelLayoutItem("key", 0, y, 1, 1, null, lconstr));
        append(new GridBagLayoutItem("key", 1, y++, 1, 1, null, null, false, "key", fieldProps, fconstr));
        append(new GridBagLabelLayoutItem("value", 0, y, 1, 1, null, lconstr));
        append(new GridBagLayoutItem("value", 1, y++, 1, 1, null, null, false, "key", fieldProps, fconstr));

        for (int i = 0; locale != null && i < locale.length; ++i) {
            append(new GridBagLabelLayoutItem(locale[i], 0, y, 1, 1, null, lconstr));
            append(new GridBagLayoutItem(locale[i], 1, y++, 1, 1, null, null, false, "key", fieldProps, fconstr));
        }
    }
}
