//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.tools.properties.model;

import com.nexirius.framework.datamodel.ArrayModel;
import com.nexirius.framework.datamodel.DataModelEnumeration;

import java.util.Locale;

public class LocaleArrayModel extends ArrayModel {

    public static LocaleModel EN = new LocaleModel(Locale.ENGLISH);
    public static LocaleModel DE = new LocaleModel(Locale.GERMAN);
    public static LocaleModel FR = new LocaleModel(Locale.FRENCH);
    public static LocaleModel IT = new LocaleModel(Locale.ITALIAN);

    public LocaleArrayModel() {
        super(new LocaleModel(), "LocaleArray");
        init();
    }

    private void init() {
        append(EN);
        append(DE);
        append(FR);
        append(IT);

        setDefault(EN);
    }

    private void setDefault(LocaleModel locale) {
        DataModelEnumeration en = getEnumeration();

        while (en.hasMore()) {
            LocaleModel lm = (LocaleModel) en.next();

            String lang = lm.getFileExtension();
            lm.setDefault(lang.equals(locale.getFileExtension()));
        }
    }
}
