//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util;

import java.io.*;

public class LineBreaker {



    public static String CR = "\n";

    static int lineBreak(int columns, InputStream in, OutputStream out)
            throws IOException {
        int c;
        int column = 0;
        int row = 0;
        ByteArrayOutputStream buf = new ByteArrayOutputStream();

        while (true) {
            c = in.read();

            if (c < 0) {
                break;
            }

            if (column < columns) {
                if (Character.isLetterOrDigit((char) c)) {
                    buf.write(c);
                } else {
                    // empty buffer on actual row
                    out.write(buf.toByteArray());
                    out.write(c);
                    buf.reset();
                }

                ++column;
            } else {
                // if the buffer is the same size as columns then empty the buffer on the actual row
                if (buf.size() == columns - 1) {
                    // empty buffer on actual row
                    out.write(buf.toByteArray());
                    buf.reset();
                    out.write(CR.getBytes());
                    out.write(c);
                    column = 1;
                } else {
                    // break on last row
                    out.write(CR.getBytes());
                    // empty buffer on the new row
                    out.write(buf.toByteArray());
                    column = buf.size() + 1;
                    buf.reset();

                    if (Character.isLetterOrDigit((char) c)) {
                        buf.write(c);
                    } else {
                        out.write(c);
                    }
                }
                ++row;
            }
        }

        return row;
    }

    public static void main(String argv[])
            throws IOException {
        String a = "Ich bin heute zu hause bei meiner Familie am Computer. DiesisteinlangesWort!01234567890123456789012345678901234567890";
        InputStream in = new ByteArrayInputStream(a.getBytes());
        OutputStream out = new ByteArrayOutputStream();

        LineBreaker.lineBreak(10, in, out);

        System.out.println(out.toString());
    }
}
