//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util;

import java.io.IOException;

class TestTextFile {
    public static void main(String argv[])
            throws Exception {
        String filename = new String("c:\\temp\\foo.txt");
        String id = new String("foo file");
        int i;

        System.out.println("START");

        if (argv != null) {
            if (argv.length >= 1) {
                filename = argv[0];
            }
        }

        TextFile tf = new TextFile(filename);

        tf.setIgnore(false, false, false);

        try {
            if (tf.exists()) {
                tf.openExistingFileForWrite(id, 1);
            } else {
                tf.openNewFileForWrite(id, 1);
            }
        } catch (IOException ex) {
            System.out.println(ex);
        }

        try {

            for (i = 0; i < 10; ++i) {
                tf.write(100000l + i);
                tf.write(',');
            }

            tf.writeNewLine();
            tf.writeString("This is a text element with a \\u0000 and a ffff in it \"\u0000\" \"\uffff\"\n");
            tf.writeNewLine();
            tf.write(12.3);
            tf.writeTab();
            tf.write(-12.3456);
            tf.writeNewLine();
            tf.write('-');
            tf.writeNewLine();

            tf.close();
        } catch (IOException ex) {
            System.out.println(ex);
        }

        try {
            tf.openForRead(id);
        } catch (IOException ex) {
            System.out.println("can't open for read:" + filename);
            System.exit(-1);
        }

        while (true) {
            try {
                TextToken token = tf.nextToken();

                if (token == null) {
                    break;
                }

                token.debugPrint();

                if (token.isString()) {
                    System.out.println("String:" + token.getString());
                }
            } catch (IOException ex) {
                System.out.println(ex);
                break;
            }
        }

        throw new Exception("END");
    }
}
