//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util;

public interface XFileJob {
    /**
     * Do something on the next subdirectory
     * @param dir the actual directory
     * @param subdirName the name of the next subdirectory
     * @return true if true then this directory will recursively be worked
     */
    public boolean workDirectory(XFile dir, String subdirName);

    /**
     * Do something on the actual file
     * @param dir the actual directory
     * @param fileName
     */
    public void work(XFile dir, String fileName);

    /**
     * Ask for interruption of the file scanning process
     * @param on
     */
    public void setInterrupted(boolean on);

    /**
     * Stop the file traversal if true
     * @return if true then the traversal stops immediately
     */
    public boolean isInterrupted();
}
