//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.locale;

import java.util.EventObject;
import java.util.Locale;

/**
 * This method was created in VisualAge
 *
 * @author Marcel Baumann
 * @invariant
 */
public class LocaleEvent extends EventObject {



    private Locale locale;

    /**
     * LocaleEvent constructor comment.
     *
     * @param source java.lang.Object
     * @param locale java.util.Locale;
     */
    public LocaleEvent(Object source, Locale locale) {
        super(source);
        if (locale == null) {
            throw new IllegalArgumentException("Parameter locale cannot be null");
        }
        this.locale = locale;
    }

    /**
     * This method was created in VisualAge
     *
     * @return java.util.Locale
     * @author Marcel Baumann
     * @post result == this.locale
     */
    public Locale getLocale() {
        return this.locale;
    }
}
