//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.statemachine;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

public class Test {



    class MyEventSource implements EventSource {
        InputStream in;

        MyEventSource(InputStream i) {
            in = i;
        }

        public String getNextEvent() {
            try {
                int c = in.read();

                if (c < 0) {
                    return null;
                }

                return new String("" + (char) c);
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }
        }

        public void pushBackEvent(String event) {
        }
    }

    public void run()
            throws Exception {
        EventSource es = new MyEventSource(new ByteArrayInputStream("kljfdlghdasf11121231234jdaslgkdhs".getBytes()));

        State _B = new State("B", es);
        State _1 = new State("1", es);
        State _2 = new State("2", es);
        State _3 = new State("3", es);
        State _4 = new State("4", es);
        State _E = new State("E", true);

        new Transition(_B, null, _B);
        new Transition(_B, "1", _1);
        new Transition(_B, "-1", _E);

        new Transition(_1, null, _B);
        new Transition(_1, "2", _2);
        new Transition(_1, "1", _1);
        new Transition(_1, "-1", _E);

        new Transition(_2, null, _B);
        new Transition(_2, "3", _3);
        new Transition(_2, "1", _1);
        new Transition(_2, "-1", _E);

        new Transition(_3, null, _B);
        new Transition(_3, "4", _4);
        new Transition(_3, "1", _1);
        new Transition(_3, "-1", _E);

        StateMachine sm = new StateMachine(_B);

        sm.run();

        sm.run(new MyEventSource(new ByteArrayInputStream("kljfdlghdasf11121231234jdaslgkdhs".getBytes())));
    }

    public static void main(String argv[])
            throws Exception {
        new Test().run();
    }
}


